<template>
  <div>
    <!--查询区域-->
    <div class="jeecg-basic-table-form-container">
      <a-form @keyup.enter.native="searchQuery" :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
        <a-row :gutter="24">
          <a-col :lg="8">
            <a-form-item label="公众号唯一id">
              <a-input placeholder="请输入公众号唯一id" v-model:value="queryParam.msgBiz"></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="8">
            <a-form-item label="公众号名称">
              <a-input placeholder="请输入公众号名称" v-model:value="queryParam.wechatTitle"></a-input>
            </a-form-item>
          </a-col>
          <template v-if="toggleSearchStatus">
            <a-col :lg="8">
              <a-form-item label="资源链接">
                <a-input placeholder="请输入资源链接" v-model:value="queryParam.source"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="资源文章标题">
                <a-input placeholder="请输入资源文章标题" v-model:value="queryParam.title"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="文章发布时间">
                 <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择开始时间" v-model:value="queryParam.articleReleaseTime_begin" class="query-group-cust" />
                 <span class="query-group-split-cust">~</span>
                 <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择结束时间" v-model:value="queryParam.articleReleaseTime_end" class="query-group-cust" />
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="原网页内容">
                <a-input placeholder="请输入原网页内容" v-model:value="queryParam.content"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="标注后网页内容">
                <a-input placeholder="请输入标注后网页内容" v-model:value="queryParam.retMsg"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="错误个数">
                <a-input placeholder="请输入错误个数" v-model:value="queryParam.errorCount"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="标注信息">
                <a-input placeholder="请输入标注信息" v-model:value="queryParam.htmlList"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="标签原文本内容">
                <a-input placeholder="请输入标签原文本内容" v-model:value="queryParam.strList"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="定位标注信息">
                <a-input placeholder="请输入定位标注信息" v-model:value="queryParam.ahtmlList"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="是否是失效文章">
                <j-dict-select-tag placeholder="请选择是否是失效文章" v-model:value="queryParam.isInvalid" dictCode="verify_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="是否修改">
                <j-dict-select-tag placeholder="请选择是否修改" v-model:value="queryParam.isRevise" dictCode="modify_state"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="是否忽略">
                <j-dict-select-tag placeholder="请选择是否忽略" v-model:value="queryParam.isIgnore" dictCode="verify_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核时间">
                 <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择开始时间" v-model:value="queryParam.checkTime_begin" class="query-group-cust" />
                 <span class="query-group-split-cust">~</span>
                 <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择结束时间" v-model:value="queryParam.checkTime_end" class="query-group-cust" />
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核状态">
                <j-dict-select-tag placeholder="请选择复核状态" v-model:value="queryParam.checkState" dictCode="review_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核校对个数">
                <a-input placeholder="请输入复核校对个数" v-model:value="queryParam.checkErrorCount"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核信息">
                <a-input placeholder="请输入复核信息" v-model:value="queryParam.checkMessage"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="扫描次数">
                <a-input placeholder="请输入扫描次数" v-model:value="queryParam.numberScans"></a-input>
              </a-form-item>
            </a-col>
          </template>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left; overflow: hidden" class="table-page-search-submitButtons">
              <a-col :lg="6">
                <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset" style="margin-left: 8px">重置</a-button>
                <a @click="toggleSearchStatus = !toggleSearchStatus" style="margin-left: 8px">
                  {{ toggleSearchStatus ? '收起' : '展开' }}
                  <Icon :icon="toggleSearchStatus ? 'ant-design:up-outlined' : 'ant-design:down-outlined'" />
                </a>
              </a-col>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
        <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
        <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
        <a-dropdown v-if="selectedRowKeys.length > 0">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined"></Icon>
                删除
              </a-menu-item>
              <a-menu-item key="2" @click="batchIgnoreHandle">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量忽略
              </a-menu-item>
              <a-menu-item key="2" @click="batchIgnoreHandleDelete">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量取消忽略
              </a-menu-item>
              <a-menu-item key="4" @click="batchModifyTrue">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量已修改
              </a-menu-item>
              <a-menu-item key="5" @click="batchModifyFalse">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量取消已修改
              </a-menu-item>
              <a-menu-item key="5" @click="batchAddWhiteLink">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量设置单词不扫描
              </a-menu-item>
              <a-menu-item key="5" @click="batchRemoveWhiteLink">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量取消设置单词不扫描
              </a-menu-item>
            </a-menu>
          </template>
          <a-button>批量操作
            <Icon icon="mdi:chevron-down"></Icon>
          </a-button>
        </a-dropdown>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
        <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
        {{ getAreaTextByCode(text) }}
      </template>
      <!--字段回显插槽-->
      <template #aurl="{text}">
        <a :href="text" :title="text" target="_blank" >{{ subString(text)  }}</a>
      </template>
      <template #fileSlot="{text}">
        <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
        <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <LinkWechatPhoneDetectionModal ref="registerModal" @success="handleSuccess"></LinkWechatPhoneDetectionModal>




    <a-modal
      v-model:visible="visiblemodify"
      :title="'是否已经修改：'+title"
      ok-text="已经修改"
      cancel-text="取消"
      @ok="hideModalSelectOk"
      @cancel="closeModalSelect"
    >
      <div style="text-align: center">
        <div style="padding: 50px;text-align: center">
          <p  v-html="errorMessage"></p><br>
        </div>
      </div>
      <template #footer>
        <a-button @click="closeModalSelect">关闭</a-button>
        <a-button type="primary" @click="hideModalSelectCancel">未修改</a-button>
        <a-button type="primary" @click="hideModalSelectOk">已经修改</a-button>
      </template>
    </a-modal>
    <a-modal
      v-model:visible="visibleIgnore"
      :title="'是否已经忽略：'+title"
      ok-text="已经忽略"
      cancel-text="取消"
      @ok="hideIgnoreSelectOk"
      @cancel="closeIgnoreModalSelect"
    >
      <div style="text-align: center">
        <div style="padding: 50px;text-align: center">
          <p  v-html="errorMessage"></p><br>
        </div>
      </div>
      <template #footer>
        <a-button @click="closeIgnoreModalSelect">关闭</a-button>
        <a-button type="primary" @click="closeIgnoreSelect">不忽略</a-button>
        <a-button type="primary" @click="hideIgnoreSelectOk">忽略</a-button>
      </template>
    </a-modal>
    <a-modal
      v-model:visible="visibleNotScan"
      :title="'是否设置不扫描：'+title"
      ok-text="设置不扫描"
      cancel-text="取消"
      @ok="hideNotScanSelectOk"
      @cancel="closeNotScanModalSelect"
    >
      <div style="text-align: center">
        <div style="padding: 20px">
          <a-checkbox
            v-model:checked="state.checkAll"
            :indeterminate="state.indeterminate"
            @change="onCheckAllChange"
          >
            全选
          </a-checkbox>
          <a-divider />
          <a-checkbox-group v-model:value="state.checkedList" style="width: 100%;text-align: left">
            <a-row>
              <a-col :span="12">
                <a-row>
                  <a-col :span="24" v-for="item in plainOptions">
                    <a-checkbox :value="item">{{item}}</a-checkbox>
                    <div style="height: 5px"></div>
                  </a-col>
                </a-row>
              </a-col>
              <a-col :span="12">
                <a-row>
                  <a-col :span="24" v-for="item in plainOptionsHtml">
                    <div v-html="item"></div>
                    <div style="height: 5px"></div>
                  </a-col>
                </a-row>
              </a-col>
            </a-row>
          </a-checkbox-group>
        </div>
      </div>
      <template #footer>
        <a-button @click="hideModalSelect">保存</a-button>
      </template>
    </a-modal>



  </div>
</template>

<script lang="ts" name="linkwechatphonedetection-linkWechatPhoneDetection" setup>
import {ref, reactive, onBeforeMount} from 'vue';
  import { useRouter } from 'vue-router';
  import { useAppStore } from '/@/store/modules/app';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { columns } from './LinkWechatPhoneDetection.data';
  import { list, deleteOne, batchDelete, getImportUrl, getExportUrl,
    batchHAddWhiteLink,
    batchHIgnoreHandle,
    batchHIgnoreHandleDelete, batchHModifyFalse, batchHModifyTrue, batchHRemoveWhiteLink
  } from './LinkWechatPhoneDetection.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import LinkWechatPhoneDetectionModal from './components/LinkWechatPhoneDetectionModal.vue'
  import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';

  const queryParam = ref<any>({});
  const toggleSearchStatus = ref<boolean>(false);
  const registerModal = ref();

  import {defHttp} from "/@/utils/http/axios";

  const state = reactive({
    indeterminate: true,
    checkAll: false,
    checkedList: [''],
  });

  const appStore = useAppStore();

  const visible = ref<boolean>(false);
  const visibleIgnore = ref<boolean>(false);
  const visibleisWhetherToIgnore = ref<boolean>(false);

  const title = ref();
  const source = ref();
  const sensitiveList = ref();
  const wechatId = ref();
  const sensitiveArrayList = ref([]);
  const hideModalSelectCancelId = ref<number>();
  const plainOptions = [''];
  const plainOptionsHtml = [''];
  const pageUrl = ref();
  const errorMessage = ref();
  const retMsg = ref();
  const weiboId = ref();

  const ahrefHtmlList = ref([])
  const queryByIdErrorList = ref([])

  const visiblemodify = ref<boolean>(false);
  const visibleFlag = ref<boolean>(false);
  const visibleNotScan = ref<boolean>(false);

  const router = useRouter();

  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '微信手机号检测',
      api: list,
      columns,
      canResize:false,
      useSearchForm: false,
      actionColumn: {
        width: 120,
        fixed: 'right',
      },
      beforeFetch: (params) => {
        return Object.assign(params, queryParam.value);
      },
    },
    exportConfig: {
      name: "微信手机号检测",
      url: getExportUrl,
    },
	  importConfig: {
	    url: getImportUrl,
	    success: handleSuccess
	  },
  });
  const [registerTable, { reload, collapseAll, updateTableDataRecord, findTableDataRecord, getDataSource }, { rowSelection, selectedRowKeys }] = tableContext;
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 7 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });

  /**
   * 新增事件
   */
  function handleAdd() {
    registerModal.value.disableSubmit = false;
    registerModal.value.add();
  }

  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    registerModal.value.disableSubmit = false;
    registerModal.value.edit(record);
  }

  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    registerModal.value.disableSubmit = true;
    registerModal.value.edit(record);
  }

  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }

  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }

  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }

  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
      },
    ];
  }
  /**
   * 实时定位
   */
  function realTimeEdit(record: Recordable) {
    const url = router.resolve({
      path: '/MyIndexWXPhone/'+record.id
    });
    window.open(url.href);
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
      {
        label: '定位手机号',
        onClick: realTimeEdit.bind(null, record),
      },
      {
        label: '设置是否已经修改',
        onClick: handleModify.bind(null, record),
      },
      {
        label: '是否忽略',
        onClick: handlewhetherToIgnore.bind(null, record),
      },
      {
        label: '设置电话号不扫描',
        onClick: handleNotScan.bind(null, record),
      },
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
      {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        }
      }
    ]
  }

  /**
   * 查询
   */
  function searchQuery() {
    reload();
  }

  /**
   * 重置
   */
  function searchReset() {
    queryParam.value = {};
    selectedRowKeys.value = [];
    //刷新数据
    reload();
  }

  function subString(str:string){
    if(str.length > 35){
      str = str.substring(0,35) + "....."
    }
    return str
  }

  function handleCrawling() {
    defHttp.get({
      url:'/wechatpostsword/wechatPostsWord/listCrawling',
      timeout:100000,
    }).then((res)=>{
      reload()
    })
  }

  const WeiXinContentCaptureId = ref<number>();
  const visiblemodifyState = ref<boolean>(false);

  function handleDetailPhone(record: Recordable) {
    visible.value = true;
    pageUrl.value = record.source;
    retMsg.value = record.retMsg;
  }

  const showModal = (record: Recordable) => {
    title.value = record.title;
    source.value = record.sensitiveErrorList;
    WeiXinContentCaptureId.value = record.id
    visiblemodifyState.value = true;
  };
  const showModalModify = (record: Recordable) => {
    title.value = record.title;
    source.value = record.sensitiveErrorList;
    WeiXinContentCaptureId.value = record.id
    errorMessage.value = record.htmlList;
    visiblemodify.value = true;
  };

  const showModalWhetherToIgnore = (record: Recordable) => {
    title.value = record.title;
    source.value = record.sensitiveErrorList;
    WeiXinContentCaptureId.value = record.id
    errorMessage.value = record.htmlList;
    visibleIgnore.value = true;
  };

  /**
   * 详情
   */
  function handleModify(record: Recordable) {
    showModalModify(record);
  }
  function handlewhetherToIgnore(record: Recordable) {
    showModalWhetherToIgnore(record);
  }
  function handleNotScan(record: Recordable) {
    showNotScanVisiblemodify(record);
  }
  async function batchIgnoreHandle() {
    await batchHIgnoreHandle({ ids: selectedRowKeys.value }, handleSuccess);
  }
  async function batchIgnoreHandleDelete() {
    await batchHIgnoreHandleDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }
  async function batchModifyTrue() {
    await batchHModifyTrue({ ids: selectedRowKeys.value }, handleSuccess);
  }
  async function batchModifyFalse() {
    await batchHModifyFalse({ ids: selectedRowKeys.value }, handleSuccess);
  }

  async function batchAddWhiteLink() {
    await batchHAddWhiteLink({ ids: selectedRowKeys.value }, handleSuccess);
  }
  async function batchRemoveWhiteLink() {
    await batchHRemoveWhiteLink({ ids: selectedRowKeys.value }, handleSuccess);
  }
  const showNotScanVisiblemodify = (record: Recordable) => {
    plainOptions.length = 0
    plainOptionsHtml.length = 0
    state.checkedList.length = 0
    weiboId.value = "";
    weiboId.value = record.id;
    defHttp.get({
      url:'/linkwechatphonedetection/linkWechatPhoneDetection/queryByIdErrorList?id='+record.id,
      timeout:10000,
    }).then((res)=>{
      title.value = record.title;
      for (let i = 0; i < res.length; i++) {
        plainOptions[i] = res[i].wordName
        if(res[i].flag == true || res[i].flag == 'true'){
          state.checkedList[i] = res[i].wordName
        }
        plainOptionsHtml[i] = res[i].wordValue
      }
    })
    visibleNotScan.value = true;
  };

  const hideModalSelectOk = () => {
    if(WeiXinContentCaptureId.value != null){
      defHttp.get({
        url:'/linkwechatphonedetection/linkWechatPhoneDetection/queryByIdModifyTrue?id='+WeiXinContentCaptureId.value
      }).then((res)=>{
        reload();
      })
    }
    visiblemodify.value = false;
  };
  const hideModalSelectCancel = () => {
    if(WeiXinContentCaptureId.value != null){
      defHttp.get({
        url:'/linkwechatphonedetection/linkWechatPhoneDetection/queryByIdModifyFalse?id='+WeiXinContentCaptureId.value
      }).then((res)=>{
        reload();
      })
    }
    visiblemodify.value = false;
  };
  const closewhetherToIgnoreSelectCancel = () => {
    if(WeiXinContentCaptureId.value != null){
      defHttp.get({
        url:'/linkwechatphonedetection/linkWechatPhoneDetection/queryWhetherToIgnoreCancel?id='+WeiXinContentCaptureId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleisWhetherToIgnore.value = false;
  };
  const whetherToIgnoreSelectOk = () => {
    if(WeiXinContentCaptureId.value != null){
      defHttp.get({
        url:'/linkwechatphonedetection/linkWechatPhoneDetection/queryWhetherToIgnore?id='+WeiXinContentCaptureId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleisWhetherToIgnore.value = false;
  };
  const hideIgnoreSelectOk = () => {
    if(WeiXinContentCaptureId.value != null){
      defHttp.get({
        url:'/linkwechatphonedetection/linkWechatPhoneDetection/queryByIdIgnoreTrue?id='+WeiXinContentCaptureId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleIgnore.value = false;
  };
  const closeIgnoreSelect = () => {
    if(WeiXinContentCaptureId.value != null){
      defHttp.get({
        url:'/linkwechatphonedetection/linkWechatPhoneDetection/queryByIdIgnoreFalse?id='+WeiXinContentCaptureId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleIgnore.value = false;
  };
  const hideNotScanSelectOk = () => {
    if(WeiXinContentCaptureId.value != null){
      defHttp.get({
        url:'/linkwechatphonedetection/linkWechatPhoneDetection/addWhiteLink?id='+WeiXinContentCaptureId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleNotScan.value = false;
  };
  const hideModalSelect = () => {
    let params = Object.assign({ checkedList: state.checkedList },{ plainOptions: plainOptions },{ weiboId: weiboId.value });
    defHttp.post({ url: '/linkwechatphonedetection/linkWechatPhoneDetection/ignore', params }, { isTransformResponse: false }).then((res) => {
    });
    visibleNotScan.value = false;
  };

  const closeModalSelectCancel = () => {
    visiblemodifyState.value = false;
  };

  const closewhetherToIgnore = () => {
    visibleisWhetherToIgnore.value = false;
  };

  const closeModalSelect = () => {
    visiblemodify.value = false;
  };
  const closeIgnoreModalSelect = () => {
    visibleIgnore.value = false;
  };
  const closeNotScanModalSelect = () => {
    visibleNotScan.value = false;
  };
  const onCheckAllChange = (e: any) => {
    Object.assign(state, {
      checkedList: e.target.checked ? plainOptions : [],
      indeterminate: false,
    });
  };

  onBeforeMount(()=>{
    queryParam.value.isIgnore = "1"
    var mainSite = localStorage.getItem("main_site");
    if(mainSite != null){
      try {
        var objMainSite = JSON.parse(mainSite);
        if(objMainSite.mainSiteUrl != null && objMainSite.mainSiteUrl != ""){
          queryParam.value.mainUrl = "*"+objMainSite.mainSiteUrl+"*"
        }
      }catch (err){
        queryParam.value.mainUrl = null
      }
    }else {
      queryParam.value.mainUrl = null
    }
    localStorage.removeItem("query_param");
    localStorage.setItem("query_param",JSON.stringify(queryParam));
  })

</script>

<style lang="less" scoped>
  .jeecg-basic-table-form-container {
    .table-page-search-submitButtons {
      display: block;
      margin-bottom: 24px;
      white-space: nowrap;
    }
    .query-group-cust{
      width: calc(50% - 15px);
      min-width: 100px !important;
    }
    .query-group-split-cust{
      width: 30px;
      display: inline-block;
      text-align: center
    }
  }
</style>
